VERSION 8000; ; 8300
* -----------------------------------------------------------------------------
* @filedoc
* @file PuWo_Importieren.CSX
* @brief Bsp. fr Koordinaten Import inPunktwolke 
* 
* Beispiel: Punktwolke (bzw. Scannerpunkte) aus allen Dateien mit gleicher Dateiendung einlesen
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author BB
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------

* Vereinbarungen -------------------------------------------------------------------------------------

BILDSCHIRM GRAFIK                           | gibt die Meldungen im Arbeitsprotokoll aus

* Zuweisungen ----------------------------------------------------------------------------------------

NPkt = 0         | Zhler 
Rot = 0          | RGB-Wert
Gruen = 0        | RGB-Wert
Blau = 0         | RGB-Wert
!Name = "*"

* Deklarationen --------------------------------------------------------------------------------------

SYMBOLE /POINTCLOUDSYS/ PointCloudSys       | Symbol fr das Punktwolkensystem
SYMBOLE /POINTCLOUD/ Punktwolke             | Symbol fr die Punktwolke
SYMBOLE /POINTCLOUDIMPORT/ PWImport         | Symbol fr den Punktwolkenimport

* Ausfhrungen ---------------------------------------------------------------------------------------

MELDE "Punktwolke aus Dateien einlesen"

* Systemobjekte
PointCloudSys = Project.GetPointCloudSys()  | liefert das Objekt fr das Punktwolkensystem

* Punktwolkenobjekt
Punktwolke = PointCloudSys.GetPointCloud(0) | liefert die aktuelle Punktwolke  
WENN Punktwolke == $NULL DANN                                                           | Wenn keine Punktwolke vorhanden ist,
  Punktwolke = PointCloudSys.CreatePointCloud("Test-Punktwolke"; "Punktwolke fr Test") | wird eine neue Punktwolke erzeugt
  WENN Punktwolke == $NULL DANN STOP MELDE "Punktwolke konnte nicht angelegt werden --> Import der Punktwolke wird abgebrochen!"
WEITER

* Importobjekt fr Punktwolke
PWImport = Punktwolke.GetCloudImport()      | liefert das Objekt fr den Punktwolkenimport 
Ret = PWImport.Create()                     | legt eine neue Zwischendatei an
WENN Ret == 0 DANN STOP MELDE "Zwischendatei konnte nicht angelegt werden --> Import der Punktwolke wird abgebrochen!"

* Schleife zum ffnen und Lesen der Dateien
DAT_SUCHEN "*.GRF"                                    | setzt das Namensmuster
SCHLEIFE I = 1; 1000

  DAT_GEFUNDEN !Name                                  | liefert nchsten Dateinamen
  WENN T_GLEICH(!Name; "*") DANN ABBRUCH SCHLEIFE     | alle Dateien sind abgearbeitet
  MELDE "Datei #"; !Name    
  DAT_AUF 1; NAME = !Name                             | ffnet eine vorhandene Datei

  * Schleife zum Lesen der Daten
  Ret = 0
  SCHLEIFE Iz = 1; 50000000
    DAT_LESEN 1; Ret; "*"; X; Y; Z; Rot; Gruen; Blau  | liest eine Dateizeile
                         |3466390.12 5508199.12 192.03 12 111 2
    WENN Ret <> 0 DANN ABBRUCH SCHLEIFE
    Npkt = Npkt + 1
    PWImport.AddPoint(X; Y; Z; Rot; Gruen; Blau)      | fgt einen Scannerpunkt hinzu 
  ENDE SCHLEIFE

  DAT_ZU 1                                            | schliet die Datei

ENDE SCHLEIFE

PWImport.Close()                                      | schliet die aktuelle Zwischendatei 
MELDE "# Punkte in die Zwischendatei eingelesen"; Npkt
Punktwolke.MakeCloud(4)                               | erzeugt aus der Zwischendatei die auswertbare Punktwolke
MELDE "Punktwolke aus Zwischendatei erzeugt"
PWImport.Delete()                                     | lscht die aktuelle Zwischendatei  
MELDE "Zwischendatei gelscht"

MELDUNG NEUTRAL "Import der Punktwolke abgeschlossen" 